﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EStudy.Domain.Model.CustomValidations
{
    public class Range : EStudyValidationAttribute
    {
        private int _max; 

        public Range(int max, string message)
        {
            _max = max;
            Message = message; 
        }

        public override bool IsValid(object itemToValidate)
        {
            if(String.IsNullOrEmpty(itemToValidate as String)) return true; 

            // check the length 

            if((itemToValidate as String).Length > _max) return false;

            return true; 
        }
    }
}
