using System;

using Mindscape.LightSpeed;
using Mindscape.LightSpeed.Validation;
using Mindscape.LightSpeed.Linq;

namespace EStudy.Domain.Model
{
  [Serializable]
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  [Table("CourseRegistrations", IdColumnName="CourseRegistrationId")]
  [System.ComponentModel.DataObject]
  public partial class CourseRegistration : Entity<int>
  {
    #region Fields
  
    private int _courseId;
    private int _userId;

    #endregion
    
    #region Field attribute and view names
    
    /// <summary>Identifies the CourseId entity attribute.</summary>
    public const string CourseIdField = "CourseId";
    /// <summary>Identifies the UserId entity attribute.</summary>
    public const string UserIdField = "UserId";


    #endregion
    
    #region Relationships

    [ReverseAssociation("CourseRegistrations")]
    private readonly EntityHolder<Course> _course = new EntityHolder<Course>();
    [ReverseAssociation("CourseRegistrations")]
    private readonly EntityHolder<User> _user = new EntityHolder<User>();


    #endregion
    
    #region Properties

    public Course Course
    {
      get { return Get(_course); }
      set { Set(_course, value); }
    }

    public User User
    {
      get { return Get(_user); }
      set { Set(_user, value); }
    }


    /// <summary>Gets or sets the ID for the <see cref="Course" /> property.</summary>
    public int CourseId
    {
      get { return Get(ref _courseId, "CourseId"); }
      set { Set(ref _courseId, value, "CourseId"); }
    }

    /// <summary>Gets or sets the ID for the <see cref="User" /> property.</summary>
    public int UserId
    {
      get { return Get(ref _userId, "UserId"); }
      set { Set(ref _userId, value, "UserId"); }
    }

    #endregion
  }


  [Serializable]
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  [Table("Courses", IdColumnName="CourseId")]
  [System.ComponentModel.DataObject]
  public partial class Course : Entity<int>
  {
    #region Fields
  
    private bool _active;
    private int _capacity;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _classCode;
    private System.DateTime _dateCreated;
    private System.DateTime _dateModified;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _name;
    private int _departmentId;

    #endregion
    
    #region Field attribute and view names
    
    /// <summary>Identifies the Active entity attribute.</summary>
    public const string ActiveField = "Active";
    /// <summary>Identifies the Capacity entity attribute.</summary>
    public const string CapacityField = "Capacity";
    /// <summary>Identifies the ClassCode entity attribute.</summary>
    public const string ClassCodeField = "ClassCode";
    /// <summary>Identifies the DateCreated entity attribute.</summary>
    public const string DateCreatedField = "DateCreated";
    /// <summary>Identifies the DateModified entity attribute.</summary>
    public const string DateModifiedField = "DateModified";
    /// <summary>Identifies the Name entity attribute.</summary>
    public const string NameField = "Name";
    /// <summary>Identifies the DepartmentId entity attribute.</summary>
    public const string DepartmentIdField = "DepartmentId";


    #endregion
    
    #region Relationships

    [ReverseAssociation("Course")]
    private readonly EntityCollection<CourseRegistration> _courseRegistrations = new EntityCollection<CourseRegistration>();
    [ReverseAssociation("Courses")]
    private readonly EntityHolder<Department> _department = new EntityHolder<Department>();


    #endregion
    
    #region Properties

    public EntityCollection<CourseRegistration> CourseRegistrations
    {
      get { return Get(_courseRegistrations); }
    }

    public Department Department
    {
      get { return Get(_department); }
      set { Set(_department, value); }
    }


    public bool Active
    {
      get { return Get(ref _active, "Active"); }
      set { Set(ref _active, value, "Active"); }
    }

    public int Capacity
    {
      get { return Get(ref _capacity, "Capacity"); }
      set { Set(ref _capacity, value, "Capacity"); }
    }

    public string ClassCode
    {
      get { return Get(ref _classCode, "ClassCode"); }
      set { Set(ref _classCode, value, "ClassCode"); }
    }

    public System.DateTime DateCreated
    {
      get { return Get(ref _dateCreated, "DateCreated"); }
      set { Set(ref _dateCreated, value, "DateCreated"); }
    }

    public System.DateTime DateModified
    {
      get { return Get(ref _dateModified, "DateModified"); }
      set { Set(ref _dateModified, value, "DateModified"); }
    }

    public string Name
    {
      get { return Get(ref _name, "Name"); }
      set { Set(ref _name, value, "Name"); }
    }

    /// <summary>Gets or sets the ID for the <see cref="Department" /> property.</summary>
    public int DepartmentId
    {
      get { return Get(ref _departmentId, "DepartmentId"); }
      set { Set(ref _departmentId, value, "DepartmentId"); }
    }

    #endregion
  }


  [Serializable]
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  [Table("Departments", IdColumnName="DepartmentId")]
  [System.ComponentModel.DataObject]
  public partial class Department : Entity<int>
  {
    #region Fields
  
    private bool _active;
    private System.DateTime _dateCreated;
    private System.DateTime _dateModified;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _title;

    #endregion
    
    #region Field attribute and view names
    
    /// <summary>Identifies the Active entity attribute.</summary>
    public const string ActiveField = "Active";
    /// <summary>Identifies the DateCreated entity attribute.</summary>
    public const string DateCreatedField = "DateCreated";
    /// <summary>Identifies the DateModified entity attribute.</summary>
    public const string DateModifiedField = "DateModified";
    /// <summary>Identifies the Title entity attribute.</summary>
    public const string TitleField = "Title";


    #endregion
    
    #region Relationships

    [ReverseAssociation("Department")]
    private readonly EntityCollection<Course> _courses = new EntityCollection<Course>();


    #endregion
    
    #region Properties

    public EntityCollection<Course> Courses
    {
      get { return Get(_courses); }
    }


    public bool Active
    {
      get { return Get(ref _active, "Active"); }
      set { Set(ref _active, value, "Active"); }
    }

    public System.DateTime DateCreated
    {
      get { return Get(ref _dateCreated, "DateCreated"); }
      set { Set(ref _dateCreated, value, "DateCreated"); }
    }

    public System.DateTime DateModified
    {
      get { return Get(ref _dateModified, "DateModified"); }
      set { Set(ref _dateModified, value, "DateModified"); }
    }

    public string Title
    {
      get { return Get(ref _title, "Title"); }
      set { Set(ref _title, value, "Title"); }
    }

    #endregion
  }


  [Serializable]
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  [Table("Roles", IdColumnName="RoleId")]
  [System.ComponentModel.DataObject]
  public partial class Role : Entity<int>
  {
    #region Fields
  
    private bool _active;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _roleName;

    #endregion
    
    #region Field attribute and view names
    
    /// <summary>Identifies the Active entity attribute.</summary>
    public const string ActiveField = "Active";
    /// <summary>Identifies the RoleName entity attribute.</summary>
    public const string RoleNameField = "RoleName";


    #endregion
    
    #region Relationships

    [ReverseAssociation("Role")]
    private readonly EntityCollection<UserRole> _userRoles = new EntityCollection<UserRole>();


    #endregion
    
    #region Properties

    public EntityCollection<UserRole> UserRoles
    {
      get { return Get(_userRoles); }
    }


    public bool Active
    {
      get { return Get(ref _active, "Active"); }
      set { Set(ref _active, value, "Active"); }
    }

    public string RoleName
    {
      get { return Get(ref _roleName, "RoleName"); }
      set { Set(ref _roleName, value, "RoleName"); }
    }

    #endregion
  }


  [Serializable]
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  [Table("UserRoles", IdColumnName="UserRoleId")]
  [System.ComponentModel.DataObject]
  public partial class UserRole : Entity<int>
  {
    #region Fields
  
    private int _roleId;
    private int _userId;

    #endregion
    
    #region Field attribute and view names
    
    /// <summary>Identifies the RoleId entity attribute.</summary>
    public const string RoleIdField = "RoleId";
    /// <summary>Identifies the UserId entity attribute.</summary>
    public const string UserIdField = "UserId";


    #endregion
    
    #region Relationships

    [ReverseAssociation("UserRoles")]
    private readonly EntityHolder<Role> _role = new EntityHolder<Role>();
    [ReverseAssociation("UserRoles")]
    private readonly EntityHolder<User> _user = new EntityHolder<User>();


    #endregion
    
    #region Properties

    public Role Role
    {
      get { return Get(_role); }
      set { Set(_role, value); }
    }

    public User User
    {
      get { return Get(_user); }
      set { Set(_user, value); }
    }


    /// <summary>Gets or sets the ID for the <see cref="Role" /> property.</summary>
    public int RoleId
    {
      get { return Get(ref _roleId, "RoleId"); }
      set { Set(ref _roleId, value, "RoleId"); }
    }

    /// <summary>Gets or sets the ID for the <see cref="User" /> property.</summary>
    public int UserId
    {
      get { return Get(ref _userId, "UserId"); }
      set { Set(ref _userId, value, "UserId"); }
    }

    #endregion
  }


  [Serializable]
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  [Table("Users", IdColumnName="UserId")]
  [System.ComponentModel.DataObject]
  public partial class User : Entity<int>
  {
    #region Fields
  
    private bool _active;
    private System.DateTime _dateCreated;
    private System.DateTime _dateModified;
    [ValidatePresence]
    [ValidateEmailAddress]
    [ValidateLength(0, 50)]
    private string _email;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _firstName;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _lastName;
    [ValidateLength(0, 50)]
    private string _middleName;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _password;
    [ValidatePresence]
    [ValidateLength(0, 50)]
    private string _userName;

    #endregion
    
    #region Field attribute and view names
    
    /// <summary>Identifies the Active entity attribute.</summary>
    public const string ActiveField = "Active";
    /// <summary>Identifies the DateCreated entity attribute.</summary>
    public const string DateCreatedField = "DateCreated";
    /// <summary>Identifies the DateModified entity attribute.</summary>
    public const string DateModifiedField = "DateModified";
    /// <summary>Identifies the Email entity attribute.</summary>
    public const string EmailField = "Email";
    /// <summary>Identifies the FirstName entity attribute.</summary>
    public const string FirstNameField = "FirstName";
    /// <summary>Identifies the LastName entity attribute.</summary>
    public const string LastNameField = "LastName";
    /// <summary>Identifies the MiddleName entity attribute.</summary>
    public const string MiddleNameField = "MiddleName";
    /// <summary>Identifies the Password entity attribute.</summary>
    public const string PasswordField = "Password";
    /// <summary>Identifies the UserName entity attribute.</summary>
    public const string UserNameField = "UserName";


    #endregion
    
    #region Relationships

    [ReverseAssociation("User")]
    private readonly EntityCollection<CourseRegistration> _courseRegistrations = new EntityCollection<CourseRegistration>();
    [ReverseAssociation("User")]
    private readonly EntityCollection<UserRole> _userRoles = new EntityCollection<UserRole>();


    #endregion
    
    #region Properties

    public EntityCollection<CourseRegistration> CourseRegistrations
    {
      get { return Get(_courseRegistrations); }
    }

    public EntityCollection<UserRole> UserRoles
    {
      get { return Get(_userRoles); }
    }


    public bool Active
    {
      get { return Get(ref _active, "Active"); }
      set { Set(ref _active, value, "Active"); }
    }

    public System.DateTime DateCreated
    {
      get { return Get(ref _dateCreated, "DateCreated"); }
      set { Set(ref _dateCreated, value, "DateCreated"); }
    }

    public System.DateTime DateModified
    {
      get { return Get(ref _dateModified, "DateModified"); }
      set { Set(ref _dateModified, value, "DateModified"); }
    }

    public string Email
    {
      get { return Get(ref _email, "Email"); }
      set { Set(ref _email, value, "Email"); }
    }

    public string FirstName
    {
      get { return Get(ref _firstName, "FirstName"); }
      set { Set(ref _firstName, value, "FirstName"); }
    }

    public string LastName
    {
      get { return Get(ref _lastName, "LastName"); }
      set { Set(ref _lastName, value, "LastName"); }
    }

    public string MiddleName
    {
      get { return Get(ref _middleName, "MiddleName"); }
      set { Set(ref _middleName, value, "MiddleName"); }
    }

    public string Password
    {
      get { return Get(ref _password, "Password"); }
      set { Set(ref _password, value, "Password"); }
    }

    public string UserName
    {
      get { return Get(ref _userName, "UserName"); }
      set { Set(ref _userName, value, "UserName"); }
    }

    #endregion
  }



  /// <summary>
  /// Provides a strong-typed unit of work for working with the EStudyModel model.
  /// </summary>
  [System.CodeDom.Compiler.GeneratedCode("LightSpeedModelGenerator", "1.0.0.0")]
  public partial class EStudyModelUnitOfWork : Mindscape.LightSpeed.UnitOfWork
  {
    /// <summary>
    /// Initializes a new instance of the EStudyModelUnitOfWork class.
    /// </summary>
    [System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never)]
    public EStudyModelUnitOfWork()
    {
    }
    

    public System.Linq.IQueryable<CourseRegistration> CourseRegistrations
    {
      get { return this.Query<CourseRegistration>(); }
    }
    
    public System.Linq.IQueryable<Course> Courses
    {
      get { return this.Query<Course>(); }
    }
    
    public System.Linq.IQueryable<Department> Departments
    {
      get { return this.Query<Department>(); }
    }
    
    public System.Linq.IQueryable<Role> Roles
    {
      get { return this.Query<Role>(); }
    }
    
    public System.Linq.IQueryable<UserRole> UserRoles
    {
      get { return this.Query<UserRole>(); }
    }
    
    public System.Linq.IQueryable<User> Users
    {
      get { return this.Query<User>(); }
    }
    
  }

}
